/*
 * Copyright (c) 2018, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations und
 */
package org.wso2.carbon.identity.piicontroller;

/**
 * This class is used to define the constants used in consent management module.
 */
public class ConsentConstants {

    public static final String PII_CONTROLLER = "piiController";
    public static final String CONTACT = "contact";
    public static final String EMAIL = "email";
    public static final String PHONE = "phone";
    public static final String ON_BEHALF = "onBehalf";
    public static final String PII_CONTROLLER_URL = "piiControllerUrl";
    public static final String ADDRESS_COUNTRY = "addressCountry";
    public static final String ADDRESS_LOCALITY = "addressLocality";
    public static final String ADDRESS_REGION = "addressRegion";
    public static final String POST_OFFICE_BOX_NUMBER = "postOfficeBoxNumber";
    public static final String POSTAL_CODE = "postalCode";
    public static final String STREET_ADDRESS = "streetAddress";
    public static final String PUBLIC_KEY = "publicKey";

    public static final String PII_CONTROLLER_CONNECTOR_NAME = "pii-controller";
    public static final String PII_CONTROLLER_CONNECTOR_FAMILY_NAME = "PII Controller";
    public static final String PII_CONTROLLER_CONNECTOR_CATEGORY = "Consent Management";
    public static final String PII_CONTROLLER_CONNECTOR_SUB_CATEGORY = "DEFAULT";

}
